﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IteratorMethods {

	class A : IEnumerable<int> {
		System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator() {
			return GetEnumerator();
		}

		public IEnumerator<int> GetEnumerator() {
			return GetEnumerator(0);
		}

		public IEnumerator<int> GetEnumerator(int alpha) {
			Console.WriteLine("\tA");
			Y1: yield return 0;
			Console.WriteLine("\tB");
			int i = 1;
			while (i < 4) {
				Console.WriteLine("\tC");
				if (i % 2 == alpha) {
					Console.WriteLine("\tD1");
				Y2: yield return i;
					Console.WriteLine("\tD2");
				} else {
					Console.WriteLine("\tE1");
				Y3: yield return i;
					Console.WriteLine("\tE2");
				}
				i++;
			}
			Console.WriteLine("\tF");
			Y4: yield return 42;
			Console.WriteLine("\tG");
		}
	}
	
	class Program {
		static void Main(string[] args) {
			A a = new A();

			Console.WriteLine("Main: before foreach");
			foreach (int i in a) {
				Console.WriteLine("Main: got {0}", i);
			}
			Console.WriteLine("Main: after foreach");
		}
	}
}
